Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -6024,235 +6050,208 @@
     REAL(wp) ::  h_out                     !<
     REAL(wp) ::  h_real                    !< new hydrogen ion conc.
-    REAL(wp) ::  H2SO4_hcl                 !< contribution of H2SO4       
-    REAL(wp) ::  H2SO4_hno3                !< contribution of H2SO4
-    REAL(wp) ::  H2SO4_nh3                 !< contribution of H2SO4
-    REAL(wp) ::  H2SO4_nh4hso4             !< contribution of H2SO4       
-    REAL(wp) ::  HCL_h2so4                 !< contribution of HCL        
-    REAL(wp) ::  HCL_hhso4                 !< contribution of HCL        
-    REAL(wp) ::  HCL_hno3                  !< contribution of HCL
-    REAL(wp) ::  HCL_nh3                   !< contribution of HCL
-    REAL(wp) ::  HCL_nh4hso4               !< contribution of HCL 
-    REAL(wp) ::  henrys_temp_dep           !< temperature dependence of 
-                                           !< Henry's Law       
-    REAL(wp) ::  HNO3_h2so4                !< contribution of HNO3       
-    REAL(wp) ::  HNO3_hcl                  !< contribution of HNO3
-    REAL(wp) ::  HNO3_hhso4                !< contribution of HNO3
-    REAL(wp) ::  HNO3_nh3                  !< contribution of HNO3
-    REAL(wp) ::  HNO3_nh4hso4              !< contribution of HNO3
-    REAL(wp) ::  hso4_out                  !< 
+    REAL(wp) ::  h2so4_hcl                 !< contribution of H2SO4
+    REAL(wp) ::  h2so4_hno3                !< contribution of H2SO4
+    REAL(wp) ::  h2so4_nh3                 !< contribution of H2SO4
+    REAL(wp) ::  h2so4_nh4hso4             !< contribution of H2SO4
+    REAL(wp) ::  hcl_h2so4                 !< contribution of HCL
+    REAL(wp) ::  hcl_hhso4                 !< contribution of HCL
+    REAL(wp) ::  hcl_hno3                  !< contribution of HCL
+    REAL(wp) ::  hcl_nh4hso4               !< contribution of HCL
+    REAL(wp) ::  henrys_temp_dep           !< temperature dependence of Henry's Law
+    REAL(wp) ::  hno3_h2so4                !< contribution of HNO3
+    REAL(wp) ::  hno3_hcl                  !< contribution of HNO3
+    REAL(wp) ::  hno3_hhso4                !< contribution of HNO3
+    REAL(wp) ::  hno3_nh3                  !< contribution of HNO3
+    REAL(wp) ::  hno3_nh4hso4              !< contribution of HNO3
+    REAL(wp) ::  hso4_out                  !<
     REAL(wp) ::  hso4_real                 !< new bisulphate ion conc.
     REAL(wp) ::  hydrochloric_acid         !<
     REAL(wp) ::  hydrochloric_acid_eq_frac !<
-    REAL(wp) ::  Kh                        !< equilibrium constant for H+       
-    REAL(wp) ::  K_hcl                     !< equilibrium constant of HCL       
-    REAL(wp) ::  K_hno3                    !< equilibrium constant of HNO3
-    REAL(wp) ::  Knh4                      !< equilibrium constant for NH4+
-    REAL(wp) ::  Kw                        !< equil. const. for water_surface  
-    REAL(wp) ::  Ln_h2so4_act              !< gamma_h2so4 = EXP(Ln_h2so4_act) 
-    REAL(wp) ::  Ln_HCL_act                !< gamma_hcl = EXP( Ln_HCL_act )
-    REAL(wp) ::  Ln_hhso4_act              !< gamma_hhso4 = EXP(Ln_hhso4_act) 
-    REAL(wp) ::  Ln_HNO3_act               !< gamma_hno3 = EXP( Ln_HNO3_act )
-    REAL(wp) ::  Ln_NH4HSO4_act            !< gamma_nh4hso4 = 
-                                           !< EXP( Ln_NH4HSO4_act )
-    REAL(wp) ::  molality_ratio_nh3        !< molality ratio of NH3 
-                                           !< (NH4+ and H+) 
-    REAL(wp) ::  Na2SO4_h2so4              !< contribution of Na2SO4                                              
-    REAL(wp) ::  Na2SO4_hcl                !< contribution of Na2SO4 
-    REAL(wp) ::  Na2SO4_hhso4              !< contribution of Na2SO4        
-    REAL(wp) ::  Na2SO4_hno3               !< contribution of Na2SO4
-    REAL(wp) ::  Na2SO4_nh3                !< contribution of Na2SO4
-    REAL(wp) ::  Na2SO4_nh4hso4            !< contribution of Na2SO4       
-    REAL(wp) ::  NaCl_h2so4                !< contribution of NaCl       
-    REAL(wp) ::  NaCl_hcl                  !< contribution of NaCl
-    REAL(wp) ::  NaCl_hhso4                !< contribution of NaCl       
-    REAL(wp) ::  NaCl_hno3                 !< contribution of NaCl
-    REAL(wp) ::  NaCl_nh3                  !< contribution of NaCl
-    REAL(wp) ::  NaCl_nh4hso4              !< contribution of NaCl       
-    REAL(wp) ::  NaNO3_h2so4               !< contribution of NaNO3       
-    REAL(wp) ::  NaNO3_hcl                 !< contribution of NaNO3
-    REAL(wp) ::  NaNO3_hhso4               !< contribution of NaNO3       
-    REAL(wp) ::  NaNO3_hno3                !< contribution of NaNO3
-    REAL(wp) ::  NaNO3_nh3                 !< contribution of NaNO3  
-    REAL(wp) ::  NaNO3_nh4hso4             !< contribution of NaNO3       
-    REAL(wp) ::  NH42SO4_h2so4             !< contribution of NH42SO4       
-    REAL(wp) ::  NH42SO4_hcl               !< contribution of NH42SO4
-    REAL(wp) ::  NH42SO4_hhso4             !< contribution of NH42SO4       
-    REAL(wp) ::  NH42SO4_hno3              !< contribution of NH42SO4
-    REAL(wp) ::  NH42SO4_nh3               !< contribution of NH42SO4
-    REAL(wp) ::  NH42SO4_nh4hso4           !< contribution of NH42SO4
-    REAL(wp) ::  NH4Cl_h2so4               !< contribution of NH4Cl       
-    REAL(wp) ::  NH4Cl_hcl                 !< contribution of NH4Cl
-    REAL(wp) ::  NH4Cl_hhso4               !< contribution of NH4Cl       
-    REAL(wp) ::  NH4Cl_hno3                !< contribution of NH4Cl
-    REAL(wp) ::  NH4Cl_nh3                 !< contribution of NH4Cl
-    REAL(wp) ::  NH4Cl_nh4hso4             !< contribution of NH4Cl       
-    REAL(wp) ::  NH4NO3_h2so4              !< contribution of NH4NO3
-    REAL(wp) ::  NH4NO3_hcl                !< contribution of NH4NO3
-    REAL(wp) ::  NH4NO3_hhso4              !< contribution of NH4NO3
-    REAL(wp) ::  NH4NO3_hno3               !< contribution of NH4NO3
-    REAL(wp) ::  NH4NO3_nh3                !< contribution of NH4NO3
-    REAL(wp) ::  NH4NO3_nh4hso4            !< contribution of NH4NO3       
+    REAL(wp) ::  k_h                       !< equilibrium constant for H+
+    REAL(wp) ::  k_hcl                     !< equilibrium constant of HCL
+    REAL(wp) ::  k_hno3                    !< equilibrium constant of HNO3
+    REAL(wp) ::  k_nh4                     !< equilibrium constant for NH4+
+    REAL(wp) ::  k_h2o                     !< equil. const. for water_surface
+    REAL(wp) ::  ln_h2so4_act              !< gamma_h2so4 = EXP(ln_h2so4_act)
+    REAL(wp) ::  ln_HCL_act                !< gamma_hcl = EXP( ln_HCL_act )
+    REAL(wp) ::  ln_hhso4_act              !< gamma_hhso4 = EXP(ln_hhso4_act)
+    REAL(wp) ::  ln_hno3_act               !< gamma_hno3 = EXP( ln_hno3_act )
+    REAL(wp) ::  ln_nh4hso4_act            !< gamma_nh4hso4 = EXP( ln_nh4hso4_act )
+    REAL(wp) ::  molality_ratio_nh3        !< molality ratio of NH3 (NH4+ and H+)
+    REAL(wp) ::  na2so4_h2so4              !< contribution of Na2SO4
+    REAL(wp) ::  na2so4_hcl                !< contribution of Na2SO4
+    REAL(wp) ::  na2so4_hhso4              !< contribution of Na2SO4
+    REAL(wp) ::  na2so4_hno3               !< contribution of Na2SO4
+    REAL(wp) ::  na2so4_nh3                !< contribution of Na2SO4
+    REAL(wp) ::  na2so4_nh4hso4            !< contribution of Na2SO4
+    REAL(wp) ::  nacl_h2so4                !< contribution of NaCl
+    REAL(wp) ::  nacl_hcl                  !< contribution of NaCl
+    REAL(wp) ::  nacl_hhso4                !< contribution of NaCl
+    REAL(wp) ::  nacl_hno3                 !< contribution of NaCl
+    REAL(wp) ::  nacl_nh3                  !< contribution of NaCl
+    REAL(wp) ::  nacl_nh4hso4              !< contribution of NaCl
+    REAL(wp) ::  nano3_h2so4               !< contribution of NaNO3
+    REAL(wp) ::  nano3_hcl                 !< contribution of NaNO3
+    REAL(wp) ::  nano3_hhso4               !< contribution of NaNO3
+    REAL(wp) ::  nano3_hno3                !< contribution of NaNO3
+    REAL(wp) ::  nano3_nh3                 !< contribution of NaNO3
+    REAL(wp) ::  nano3_nh4hso4             !< contribution of NaNO3
+    REAL(wp) ::  nh42so4_h2so4             !< contribution of NH42SO4
+    REAL(wp) ::  nh42so4_hcl               !< contribution of NH42SO4
+    REAL(wp) ::  nh42so4_hhso4             !< contribution of NH42SO4
+    REAL(wp) ::  nh42so4_hno3              !< contribution of NH42SO4
+    REAL(wp) ::  nh42so4_nh3               !< contribution of NH42SO4
+    REAL(wp) ::  nh42so4_nh4hso4           !< contribution of NH42SO4
+    REAL(wp) ::  nh4cl_h2so4               !< contribution of NH4Cl
+    REAL(wp) ::  nh4cl_hcl                 !< contribution of NH4Cl
+    REAL(wp) ::  nh4cl_hhso4               !< contribution of NH4Cl
+    REAL(wp) ::  nh4cl_hno3                !< contribution of NH4Cl
+    REAL(wp) ::  nh4cl_nh3                 !< contribution of NH4Cl
+    REAL(wp) ::  nh4cl_nh4hso4             !< contribution of NH4Cl
+    REAL(wp) ::  nh4no3_h2so4              !< contribution of NH4NO3
+    REAL(wp) ::  nh4no3_hcl                !< contribution of NH4NO3
+    REAL(wp) ::  nh4no3_hhso4              !< contribution of NH4NO3
+    REAL(wp) ::  nh4no3_hno3               !< contribution of NH4NO3
+    REAL(wp) ::  nh4no3_nh3                !< contribution of NH4NO3
+    REAL(wp) ::  nh4no3_nh4hso4            !< contribution of NH4NO3
     REAL(wp) ::  nitric_acid               !<
     REAL(wp) ::  nitric_acid_eq_frac       !< Equivalent fractions
-    REAL(wp) ::  Press_HCL                 !< partial pressure of HCL        
-    REAL(wp) ::  Press_HNO3                !< partial pressure of HNO3
-    REAL(wp) ::  Press_NH3                 !< partial pressure of NH3        
-    REAL(wp) ::  RH                        !< relative humidity [0-1]
+    REAL(wp) ::  press_hcl                 !< partial pressure of HCL
+    REAL(wp) ::  press_hno3                !< partial pressure of HNO3
+    REAL(wp) ::  press_nh3                 !< partial pressure of NH3
+    REAL(wp) ::  rh                        !< relative humidity [0-1]
+    REAL(wp) ::  root1                     !< auxiliary variable
+    REAL(wp) ::  root2                     !< auxiliary variable
+    REAL(wp) ::  so4_out                   !<
+    REAL(wp) ::  so4_real                  !< new sulpate ion concentration
+    REAL(wp) ::  sodium_chloride           !<
+    REAL(wp) ::  sodium_chloride_eq_frac   !<
+    REAL(wp) ::  sodium_nitrate            !<
+    REAL(wp) ::  sodium_nitrate_eq_frac    !<
+    REAL(wp) ::  sodium_sulphate           !<
+    REAL(wp) ::  sodium_sulphate_eq_frac   !<
+    REAL(wp) ::  solutes                   !<
+    REAL(wp) ::  sulphuric_acid            !<
+    REAL(wp) ::  sulphuric_acid_eq_frac    !<
     REAL(wp) ::  temp                      !< temperature
-    REAL(wp) ::  so4_out                   !< 
-    REAL(wp) ::  so4_real                  !< new sulpate ion concentration       
-    REAL(wp) ::  sodium_chloride           !<
-    REAL(wp) ::  sodium_chloride_eq_frac   !<   
-    REAL(wp) ::  sodium_nitrate            !<
-    REAL(wp) ::  sodium_nitrate_eq_frac    !<    
-    REAL(wp) ::  sodium_sulphate           !<
-    REAL(wp) ::  sodium_sulphate_eq_frac   !<       
-    REAL(wp) ::  solutes                   !<
-    REAL(wp) ::  sulphuric_acid            !<       
-    REAL(wp) ::  sulphuric_acid_eq_frac    !< 
     REAL(wp) ::  water_total               !<
-    
-    REAL(wp) ::  a !< auxiliary variable 
-    REAL(wp) ::  b !< auxiliary variable
-    REAL(wp) ::  c !< auxiliary variable 
-    REAL(wp) ::  root1 !< auxiliary variable 
-    REAL(wp) ::  root2 !< auxiliary variable
-
-    INTEGER(iwp) ::  binary_case
-    INTEGER(iwp) ::  full_complexity
-!       
+
+    REAL(wp), DIMENSION(:) ::  gamma_out !< Activity coefficient for calculating the non-ideal
+                                         !< dissociation constants
+                                         !< 1: HNO3, 2: HCL, 3: NH4+/H+ (NH3), 4: HHSO4**2/H2SO4,
+                                         !< 5: H2SO4**3/HHSO4**2, 6: NH4HSO2, 7: HHSO4
+    REAL(wp), DIMENSION(:) ::  ions      !< ion molarities (mol/m3): 1: H+, 2: NH4+, 3: Na+, 
+                                         !< 4: SO4(2-), 5: HSO4-, 6: NO3-, 7: Cl-
+    REAL(wp), DIMENSION(7) ::  ions_mol  !< ion molalities (mol/kg): 1: H+, 2: NH4+, 3: Na+, 
+                                         !< 4: SO4(2-), 5: HSO4-, 6: NO3-, 7: Cl-
+    REAL(wp), DIMENSION(:) ::  mols_out  !< ion molality output (mol/kg): 1: H+, 2: NH4+, 3: Na+, 
+                                         !< 4: SO4(2-), 5: HSO4-, 6: NO3-, 7: Cl-
+!
 !-- Value initialisation
-    binary_h2so4    = 0.0_wp   
-    binary_hcl      = 0.0_wp  
-    binary_hhso4    = 0.0_wp  
-    binary_hno3     = 0.0_wp  
-    binary_nh4hso4  = 0.0_wp  
-    henrys_temp_dep = ( 1.0_wp / temp - 1.0_wp / 298.0_wp )
-    HCL_hno3        = 1.0_wp
-    H2SO4_hno3      = 1.0_wp
-    NH42SO4_hno3    = 1.0_wp
-    NH4NO3_hno3     = 1.0_wp
-    NH4Cl_hno3      = 1.0_wp
-    Na2SO4_hno3     = 1.0_wp
-    NaNO3_hno3      = 1.0_wp
-    NaCl_hno3       = 1.0_wp
-    HNO3_hcl        = 1.0_wp
-    H2SO4_hcl       = 1.0_wp
-    NH42SO4_hcl     = 1.0_wp
-    NH4NO3_hcl      = 1.0_wp
-    NH4Cl_hcl       = 1.0_wp
-    Na2SO4_hcl      = 1.0_wp 
-    NaNO3_hcl       = 1.0_wp
-    NaCl_hcl        = 1.0_wp
-    HNO3_nh3        = 1.0_wp
-    HCL_nh3         = 1.0_wp
-    H2SO4_nh3       = 1.0_wp 
-    NH42SO4_nh3     = 1.0_wp 
-    NH4NO3_nh3      = 1.0_wp
-    NH4Cl_nh3       = 1.0_wp
-    Na2SO4_nh3      = 1.0_wp
-    NaNO3_nh3       = 1.0_wp
-    NaCl_nh3        = 1.0_wp
-    HNO3_hhso4      = 1.0_wp 
-    HCL_hhso4       = 1.0_wp
-    NH42SO4_hhso4   = 1.0_wp
-    NH4NO3_hhso4    = 1.0_wp
-    NH4Cl_hhso4     = 1.0_wp
-    Na2SO4_hhso4    = 1.0_wp
-    NaNO3_hhso4     = 1.0_wp
-    NaCl_hhso4      = 1.0_wp
-    HNO3_h2so4      = 1.0_wp
-    HCL_h2so4       = 1.0_wp
-    NH42SO4_h2so4   = 1.0_wp 
-    NH4NO3_h2so4    = 1.0_wp
-    NH4Cl_h2so4     = 1.0_wp
-    Na2SO4_h2so4    = 1.0_wp
-    NaNO3_h2so4     = 1.0_wp
-    NaCl_h2so4      = 1.0_wp
+    binary_h2so4    = 0.0_wp
+    binary_hcl      = 0.0_wp
+    binary_hhso4    = 0.0_wp
+    binary_hno3     = 0.0_wp
+    binary_nh4hso4  = 0.0_wp
+    henrys_temp_dep = ( 1.0_wp / temp - 0.0033557_wp ) ! 1/T - 1/298 K
+    hcl_hno3        = 1.0_wp
+    h2so4_hno3      = 1.0_wp
+    nh42so4_hno3    = 1.0_wp
+    nh4no3_hno3     = 1.0_wp
+    nh4cl_hno3      = 1.0_wp
+    na2so4_hno3     = 1.0_wp
+    nano3_hno3      = 1.0_wp
+    nacl_hno3       = 1.0_wp
+    hno3_hcl        = 1.0_wp
+    h2so4_hcl       = 1.0_wp
+    nh42so4_hcl     = 1.0_wp
+    nh4no3_hcl      = 1.0_wp
+    nh4cl_hcl       = 1.0_wp
+    na2so4_hcl      = 1.0_wp
+    nano3_hcl       = 1.0_wp
+    nacl_hcl        = 1.0_wp
+    hno3_nh3        = 1.0_wp
+    h2so4_nh3       = 1.0_wp
+    nh42so4_nh3     = 1.0_wp
+    nh4no3_nh3      = 1.0_wp
+    nh4cl_nh3       = 1.0_wp
+    na2so4_nh3      = 1.0_wp
+    nano3_nh3       = 1.0_wp
+    nacl_nh3        = 1.0_wp
+    hno3_hhso4      = 1.0_wp
+    hcl_hhso4       = 1.0_wp
+    nh42so4_hhso4   = 1.0_wp
+    nh4no3_hhso4    = 1.0_wp
+    nh4cl_hhso4     = 1.0_wp
+    na2so4_hhso4    = 1.0_wp
+    nano3_hhso4     = 1.0_wp
+    nacl_hhso4      = 1.0_wp
+    hno3_h2so4      = 1.0_wp
+    hcl_h2so4       = 1.0_wp
+    nh42so4_h2so4   = 1.0_wp
+    nh4no3_h2so4    = 1.0_wp
+    nh4cl_h2so4     = 1.0_wp
+    na2so4_h2so4    = 1.0_wp
+    nano3_h2so4     = 1.0_wp
+    nacl_h2so4      = 1.0_wp
+!
 !-- New NH3 variables
-    HNO3_nh4hso4    = 1.0_wp 
-    HCL_nh4hso4     = 1.0_wp
-    H2SO4_nh4hso4   = 1.0_wp
-    NH42SO4_nh4hso4 = 1.0_wp 
-    NH4NO3_nh4hso4  = 1.0_wp
-    NH4Cl_nh4hso4   = 1.0_wp
-    Na2SO4_nh4hso4  = 1.0_wp
-    NaNO3_nh4hso4   = 1.0_wp
-    NaCl_nh4hso4    = 1.0_wp
+    hno3_nh4hso4    = 1.0_wp
+    hcl_nh4hso4     = 1.0_wp
+    h2so4_nh4hso4   = 1.0_wp
+    nh42so4_nh4hso4 = 1.0_wp
+    nh4no3_nh4hso4  = 1.0_wp
+    nh4cl_nh4hso4   = 1.0_wp
+    na2so4_nh4hso4  = 1.0_wp
+    nano3_nh4hso4   = 1.0_wp
+    nacl_nh4hso4    = 1.0_wp
 !
 !-- Juha Tonttila added
     mols_out   = 0.0_wp
-    Press_HNO3 = 0.0_wp
-    Press_HCL  = 0.0_wp
-    Press_NH3  = 0.0_wp !< Initialising vapour pressure over the
-                        !< multicomponent particle
-    gamma_out  = 1.0_wp !< i.e. don't alter the ideal mixing ratios if 
-                        !< there's nothing there.
-!       
+    press_hno3 = 0.0_wp  !< Initialising vapour pressures over the
+    press_hcl  = 0.0_wp  !< multicomponent particle
+    press_nh3  = 0.0_wp
+    gamma_out  = 1.0_wp  !< i.e. don't alter the ideal mixing ratios if there's nothing there.
+!
 !-- 1) - COMPOSITION DEFINITIONS
 !
 !-- a) Inorganic ion pairing:
-!-- In order to calculate the water content, which is also used in 
-!-- calculating vapour pressures, one needs to pair the anions and cations 
-!-- for use in the ZSR mixing rule. The equation provided by Clegg et al. 
-!-- (2001) is used for ion pairing. The solutes chosen comprise of 9 
-!-- inorganic salts and acids which provide a pairing between each anion and
-!-- cation: (NH4)2SO4, NH4NO3, NH4Cl, Na2SO4, NaNO3, NaCl, H2SO4, HNO3, HCL.  
-!-- The organic compound is treated as a seperate solute.
+!-- In order to calculate the water content, which is also used in calculating vapour pressures, one
+!-- needs to pair the anions and cations for use in the ZSR mixing rule. The equation provided by
+!-- Clegg et al. (2001) is used for ion pairing. The solutes chosen comprise of 9 inorganic salts
+!-- and acids which provide a pairing between each anion and cation: (NH4)2SO4, NH4NO3, NH4Cl,
+!-- Na2SO4, NaNO3, NaCl, H2SO4, HNO3, HCL. The organic compound is treated as a seperate solute.
 !-- Ions: 1: H+, 2: NH4+, 3: Na+, 4: SO4(2-), 5: HSO4-, 6: NO3-, 7: Cl-
 !
-    charge_sum = ions(1) + ions(2) + ions(3) + 2.0_wp * ions(4) + ions(5) +    &
-                 ions(6) + ions(7)
-    nitric_acid       = 0.0_wp   ! HNO3
-    nitric_acid       = ( 2.0_wp * ions(1) * ions(6) *                         &
-                        ( ( 1.0_wp / 1.0_wp ) ** 0.5_wp ) ) / ( charge_sum )
-    hydrochloric_acid = 0.0_wp   ! HCL 
-    hydrochloric_acid = ( 2.0_wp * ions(1) * ions(7) *                         &
-                        ( ( 1.0_wp / 1.0_wp ) ** 0.5_wp ) ) / ( charge_sum )
-    sulphuric_acid    = 0.0_wp   ! H2SO4
-    sulphuric_acid    = ( 2.0_wp * ions(1) * ions(4) *                         &
-                        ( ( 2.0_wp / 2.0_wp ) ** 0.5_wp ) ) / ( charge_sum )
-    ammonium_sulphate = 0.0_wp   ! (NH4)2SO4
-    ammonium_sulphate = ( 2.0_wp * ions(2) * ions(4) *                         &
-                        ( ( 2.0_wp / 2.0_wp ) ** 0.5_wp ) ) / ( charge_sum ) 
-    ammonium_nitrate  = 0.0_wp   ! NH4NO3
-    ammonium_nitrate  = ( 2.0_wp * ions(2) * ions(6) *                         &
-                        ( ( 1.0_wp / 1.0_wp ) ** 0.5_wp ) ) / ( charge_sum )
-    ammonium_chloride = 0.0_wp   ! NH4Cl
-    ammonium_chloride = ( 2.0_wp * ions(2) * ions(7) *                         &
-                        ( ( 1.0_wp / 1.0_wp ) ** 0.5_wp ) ) / ( charge_sum )    
-    sodium_sulphate   = 0.0_wp   ! Na2SO4
-    sodium_sulphate   = ( 2.0_wp * ions(3) * ions(4) *                         &
-                        ( ( 2.0_wp / 2.0_wp ) ** 0.5_wp ) ) / ( charge_sum )
-    sodium_nitrate    = 0.0_wp   ! NaNO3
-    sodium_nitrate    = ( 2.0_wp * ions(3) *ions(6) *                          &
-                        ( ( 1.0_wp / 1.0_wp ) ** 0.5_wp ) ) / ( charge_sum )
-    sodium_chloride   = 0.0_wp   ! NaCl
-    sodium_chloride   = ( 2.0_wp * ions(3) * ions(7) *                         &
-                        ( ( 1.0_wp / 1.0_wp ) ** 0.5_wp ) ) / ( charge_sum )
+    charge_sum = ions(1) + ions(2) + ions(3) + 2.0_wp * ions(4) + ions(5) + ions(6) + ions(7)
+    nitric_acid       = ( 2.0_wp * ions(1) * ions(6) ) / charge_sum
+    hydrochloric_acid = ( 2.0_wp * ions(1) * ions(7) ) / charge_sum
+    sulphuric_acid    = ( 2.0_wp * ions(1) * ions(4) ) / charge_sum
+    ammonium_sulphate = ( 2.0_wp * ions(2) * ions(4) ) / charge_sum
+    ammonium_nitrate  = ( 2.0_wp * ions(2) * ions(6) ) / charge_sum
+    ammonium_chloride = ( 2.0_wp * ions(2) * ions(7) ) / charge_sum
+    sodium_sulphate   = ( 2.0_wp * ions(3) * ions(4) ) / charge_sum
+    sodium_nitrate    = ( 2.0_wp * ions(3) * ions(6) ) / charge_sum
+    sodium_chloride   = ( 2.0_wp * ions(3) * ions(7) ) / charge_sum
     solutes = 0.0_wp
-    solutes = 3.0_wp * sulphuric_acid +   2.0_wp * hydrochloric_acid +         &
-              2.0_wp * nitric_acid +      3.0_wp * ammonium_sulphate +         &
-              2.0_wp * ammonium_nitrate + 2.0_wp * ammonium_chloride +         &
-              3.0_wp * sodium_sulphate +  2.0_wp * sodium_nitrate +            &
-              2.0_wp * sodium_chloride
-
-! 
+    solutes = 3.0_wp * sulphuric_acid    + 2.0_wp * hydrochloric_acid + 2.0_wp * nitric_acid +     &
+              3.0_wp * ammonium_sulphate + 2.0_wp * ammonium_nitrate + 2.0_wp * ammonium_chloride +&
+              3.0_wp * sodium_sulphate   + 2.0_wp * sodium_nitrate   + 2.0_wp * sodium_chloride
+!
 !-- b) Inorganic equivalent fractions:
-!-- These values are calculated so that activity coefficients can be 
-!-- expressed by a linear additive rule, thus allowing more efficient
-!-- calculations and future expansion (see more detailed description below)               
-    nitric_acid_eq_frac       = 2.0_wp * nitric_acid / ( solutes )
-    hydrochloric_acid_eq_frac = 2.0_wp * hydrochloric_acid / ( solutes )
-    sulphuric_acid_eq_frac    = 3.0_wp * sulphuric_acid / ( solutes )
-    ammonium_sulphate_eq_frac = 3.0_wp * ammonium_sulphate / ( solutes )
-    ammonium_nitrate_eq_frac  = 2.0_wp * ammonium_nitrate / ( solutes )
-    ammonium_chloride_eq_frac = 2.0_wp * ammonium_chloride / ( solutes )
-    sodium_sulphate_eq_frac   = 3.0_wp * sodium_sulphate / ( solutes )
-    sodium_nitrate_eq_frac    = 2.0_wp * sodium_nitrate / ( solutes )
-    sodium_chloride_eq_frac   = 2.0_wp * sodium_chloride / ( solutes )
+!-- These values are calculated so that activity coefficients can be expressed by a linear additive
+!-- rule, thus allowing more efficient calculations and future expansion (see more detailed
+!-- description below)
+    nitric_acid_eq_frac       = 2.0_wp * nitric_acid / solutes
+    hydrochloric_acid_eq_frac = 2.0_wp * hydrochloric_acid / solutes
+    sulphuric_acid_eq_frac    = 3.0_wp * sulphuric_acid / solutes
+    ammonium_sulphate_eq_frac = 3.0_wp * ammonium_sulphate / solutes
+    ammonium_nitrate_eq_frac  = 2.0_wp * ammonium_nitrate / solutes
+    ammonium_chloride_eq_frac = 2.0_wp * ammonium_chloride / solutes
+    sodium_sulphate_eq_frac   = 3.0_wp * sodium_sulphate / solutes
+    sodium_nitrate_eq_frac    = 2.0_wp * sodium_nitrate / solutes
+    sodium_chloride_eq_frac   = 2.0_wp * sodium_chloride / solutes
 !
 !-- Inorganic ion molalities
-    ions_mol(:) = 0.0_wp
     ions_mol(1) = ions(1) / ( water_total * 18.01528E-3_wp )   ! H+
     ions_mol(2) = ions(2) / ( water_total * 18.01528E-3_wp )   ! NH4+
